open GccTypes

val new_block :
  int ->
  (arg ins list -> arg ins list) list -> arg ins list -> arg ins list
val get_size : 'a ins list -> 'a ins list -> 'a ins list
val get_tag : 'a ins list -> 'a ins list -> 'a ins list
val get_field : 'a ins list -> int -> 'a ins list -> 'a ins list
val set_field : 'a ins list -> int -> 'a ins list -> 'a ins list -> 'a ins list

val get_dyn_field:
  'a ins list -> 'a ins list -> 'a ins list -> 'a ins list
val set_dyn_field:
  'a ins list -> 'a ins list -> 'a ins list -> 'a ins list -> 'a ins list

(* Generate the "block" and "create_block" labels and instructions, until
   the provided size. *)
val builtins : unit ->  arg ins list
val lbl_y : int -> arg
val lbl_z : int -> arg
val lbl_restart : int -> arg

type bit_comp = BcAnd | BcOr | BcXor

val bit_compare_8values:
  bit_comp -> 'a ins -> 'a ins -> 'a ins list -> 'a ins list
