open GccTypes


let get_map prog =
  let rec aux prog map n n' =
    if n >= Array.length prog
    then map, n'
    else match prog.(n) with
      | LABEL (L s) -> aux prog (StringMap.add s n' map) (n+1) n'
      | LABEL _ -> assert false
      | _ -> aux prog map (n+1) (n'+1)
  in
  aux prog StringMap.empty 0 0

let conv_to_int_ins prog =
  let map,size = get_map prog in
  let a = Array.create size ADD in
  let rec aux n n' =
    if n >= size
    then a
    else match prog.(n') with
      | LABEL _ -> aux n (n'+1)
      | i -> a.(n) <- i; aux (n+1) (n'+1)
  in
  aux 0 0

