

let simple n =
  let x = ref 0 in
  for i = 1 to n do
    x := !x + i
  done;
  !x

let double n =
  let x = ref 0 in
  for i = 1 to n do
    for j = 1 to i do
      x := !x + j
    done
  done;
  !x

let reverse () =
  let x = ref [] in
  for i = 5 downto 1 do
    x := i :: !x
  done;
  match !x with
  | [1;2;3;4;5] -> true
  | _ -> false

let simple_while n =
  let x = ref 0 and i = ref 1 in
  while !i <= n do
    x := !x + !i;
    i := !i + 1
  done;
  !x

let main =
  simple 5 = 15
  && double 5 = 35
  && simple_while 5 = 15
  && reverse ()
