
let f w x y z = w - x + y * z

let g1 w x y z =
  let a = f w in
  let b = a x in
  let c = b y in
  let d = c z in
  d

let g2 w x y z =
  let a = f w in
  let b = a x in
  let c = b y z in
  c

let g3 w x y z =
  let a = f w in
  let b = a x y in
  let c = b z in
  c

let g4 w x y z =
  let a = f w in
  let b = a x y z in
  b

let h1 w x y z =
  let a = f w x in
  let b = a y in
  let c = b z in
  c

let h2 w x y z =
  let a = f w x in
  let b = a y z in
  b

let i w x y z =
  let a = f w x y in
  let b = a z in
  b

let id x = x

let plop =
  let x1 = 4 in
  let x2 = 1 in
  fun y ->
    let g z = x1 - x2 + y / z in
    g

let plip =
  let x1 = 4 in
  fun () ->
  let x2 = 1 in
  let rec f y =
    let g z = x1 - x2 + y / z in
    if y <= 5 then
      g
    else
      (fun x -> f (y - 1) x + 1)
  in
  f

let main =
  f 1 3 5 7 = 33
  && g1 1 3 5 7 = 33
  && g2 1 3 5 7 = 33
  && g3 1 3 5 7 = 33
  && g4 1 3 5 7 = 33
  && h1 1 3 5 7 = 33
  && h2 1 3 5 7 = 33
  && i 1 3 5 7 = 33
  && id f 1 3 5 7 = 33
  && plop 15 5 = 6
  && plip () 7 3 = 6
