
let x = ref 0

let () =
  x := (!x + 1) * 2

type r = { mutable x : int ; mutable y : int }

let test_record () =
  let a = { x = 666; y = 777 } in
  a.x = 666
  && a.y = 777
  && (a.x <- 333 ; a.x = 333)
  && a.y = 777

let local_assign () =
  let x = ref 0 in
  x := !x + 1;
  !x = 1

let seqor () =
  let x = ref 0 in
  ignore (true || (x := !x + 1; false));
  !x = 0

let seqand () =
  let x = ref 0 in
  ignore (false && (x := !x + 1; false));
  !x = 0

let main =
  !x = 2
  && test_record ()
  && local_assign ()
  && seqor ()
  && seqand ()
