icfp2014
========

Hi !
We're the "Lom Crapo" Team from France and I'm the worst of the team at coding, so I'm writing it while they finish up stuff

We chose to use OCaml with version 4.01.0 and to compile it to gcc.
You'll also need GNU Make and ocp-build.

To compile :

  opam switch 4.01.0
  eval `opam config env`
  opam install ocp-build
  ocp-build -init && make

directories:

- gcc/ contains our gcc interpreter and our compiler from ocaml to gcc

 -> make test_ocamlgcc # will run our testsuite inside our gcc-interpret

- gcc/player contains our mighty lambdaman code along with a lot of garbage

 -> make test_rococo # will run our lambda-man on our game-simulator
                     # main file is gcc/player/player_rococo.ml

- ghc/ contains our ghc code interpret, code generator and ghost code

 -> make test_ghc # should not do much

- display/creates a nice display for the game, check out for our 16 segments !

 -> make test_display

At some point, we were able to run our ghc interpret in the lambda-man
program, but eventually we focus our self on a simple-but-working
strategy.

Have a nice reading, and thank you for that awesome contest.



OCamlGcc compiler
=================

We use an unmodifed OCaml frontend and then handle most of the language constructions, including efficient pattern-matching on ADT (and GADT...), mutable array and record, partial-application and over-application.

Our test suite, is in gcc/test/, it covers all the implemented features.

Field access on tagged block or array is in log2 of their size, see
gcc/gccBuiltins.ml for more details on the implementation.

We "branch" our gcc-generator on the OCaml 'Lambda'. Sadly, this
lambda-code does not contain any type information. We do not tried to
recompute type-information (nor to modify OCaml in order to propagate
them). Then, our list implemtation is not the most efficient one
(i.e. it do not use 'cons' for 'cons' but it ues our generic
'tagged-block' construction).

We do not handle:

- exception
- separate compilation
- some unused base types: float, string, ...
- object

