type t = A | B | C of int | D of int * int

let f x =
  match x with
  | A -> 1
  | B -> 2
  | C x -> x
  | D (x, y) -> x + y

let rec map f l =
  match l with
  | [] -> []
  | hd :: tl -> f hd :: map f tl

let rec fold_left f acc l =
  match l with
  | [] -> acc
  | hd :: tl -> fold_left f (f acc hd) tl

let main () =
  for i = 0 to 32 do () done ;
  fold_left (+) 0 (map f [ A ; A ; B ; B ])
